<?


// ---------------------------------------------------------
//                  BLOXXY - editor blogu
// ---------------------------------------------------------
//
//	2003 (l) -pixy-  (pixy@pixy.cz)
//	freeware, beta, copyleft
//	all rights reserved, no responsibility



// do not delete this
$authors = NULL;

// ---------------------------------------------------------
//    >>>>>   Config START - edit these properties
// ---------------------------------------------------------


// These directories must exist and must be readable and writable
// for this script. E. g. crete them and set their permissions to 0777.

$path_to_config = './bloxxy-conf';
$path_to_items = './bloxxy-items';

// All files inside the "$path_to_config" directory must be readable
// and writable for this script.
// Setting their permissions to 0777 is the ultimate solution, too.


// Editor and pages language and encoding.
// possible values are 'cs-iso', 'cs-win' and 'en'
// You can create more ones - see the documentation.

$use_language = 'cs-iso';

// set PHP system locale by used language

setlocale(LC_ALL,"Czech");

// Authors allowed to edit your blog.
// Fill in proper information for each user.
// At least one user must exist to make Bloxxy work.

// To add new author, copy all three $authors['ID'] variables,
// change the index ('your_logname') and fill in proper information.
// e. g.:

// $authors['bigboss']['passwd']	= 'oH95zt78';
// $authors['bigboss']['name']		= 'The Big Boss';
// $authors['bigboss']['e-mail']	= 'big@big.boss';

// makes the user log in as "bigboss" with password 'oH95zt78'
// and his/her items will be credited to "The Big Boss"
// and linked to the e-mail big@big.boss

$authors['test']['passwd']	= 'test';
$authors['test']['name']	= 'Beta Tester';
$authors['test']['e-mail']	= 'dev@null';


// How to (and if to) use Bloxxy autoformating.
// Possible values are 'HTML', 'XHTML' and '' (or false)
// If false, text of items won't be processed

$use_autoformat = 'XHTML';

// Number of items per page when listing:

$items_perpage = 10;

// Edit text sizes:

$textarea_columns = 72;
$textarea_rows = 20;

// Monday starts a week; if false, sunday is used.

$week_starts_moday = true;


// ---------------------------------------------------------
//    Config END - do not edit anything bellow.      <<<<<
// ---------------------------------------------------------


// --- login ---

if (!$BLOXY_LOGIN) {
	$loginOK = false;
	if ($PHP_AUTH_USER && $authors[$PHP_AUTH_USER]['passwd']==$PHP_AUTH_PW) {
		$authID = $PHP_AUTH_USER;
		setcookie("BLOXY_LOGIN",$authID);
		}
	else {
		Header("WWW-Authenticate: Basic realm=\"Bloxxy login\"");
		Header("HTTP/1.0 401 Unauthorized");
		echo "Bloxxy login failed.\n";
		die();
		}
	}
else {
	$authID = $BLOXY_LOGIN;
	}

// --- inits ---

if (!file_exists($path_to_config)) die("Missing directory $path_to_config");
if (!file_exists($path_to_items)) die("Missing directory $path_to_items");

$css_file = $path_to_config.'/bloxxy.css';
$groups_file = $path_to_config.'/groups.conf';
$items_file = $path_to_config.'/items.conf';
$blogs_file = $path_to_config.'/publications.conf';
$str_file_prefix = $path_to_config.'/bloxxy-strings-';
$bxtags_file = $path_to_config.'/bxtags.inc';
$publisher_file = $path_to_config.'/publisher.inc';

if ($use_autoformat && file_exists($bxtags_file)) {
	include($bxtags_file); $BXTagsOK = true;
	}
else $BXTagsOK = false;
if (file_exists($publisher_file)) include($publisher_file);
else die("Missing Publisher ($publisher_file)");
if (file_exists($groups_file)) include($groups_file);
if (file_exists($blogs_file)) include($blogs_file);
if (file_exists($str_file_prefix.$use_language)) include ($str_file_prefix.$use_language);
else die("Missing strings file for $use_language language");


// --- read groups and items ---

$groups[0] = $BLXS['unassigned'];
$grp_list[] = array();
for ($i=0;$i<count($groups);$i++) {
	$grp_list[$i][0] = $groups[$i];
	$grp_list[$i][1] = $i;
	}
loadItemsList($items);
$blog_list[] = array();
for ($i=0;$i<count($blogs);$i++) {
	$blog_list[$i][0] = $blogs[$i]['name'];
	$blog_list[$i][1] = $i;
	}

// --- quick preview of item

if ($outact=='preview') {
	die(getItemHTML(readItem($itemid)));
	}


// --- HEADER ---

e('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/2000/REC-xhtml1-20000126/DTD/xhtml1-strict.dtd">');

e("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".$BLXS['Lang']."\" lang=\"".$BLXS['Lang']."\">");
e("<head>");
$charsetstr = ($BLXS['Charset']) ? '; charset="'.$BLXS['Charset'].'"' : '';
e("<meta http-equiv=\"content-type\" content=\"text/html$charsetstr />");
if ($css_file) e("<link rel='stylesheet' href='$css_file' />");
e("<title>".$BLXS['Editor_Title']."</title>");
e("<meta name='author' content='Petr Stanicek (pixy@pixy.cz)' />");
e("</head>");
e("<body>");


//var_dump($blogs);

eH1( $BLXS['Editor_Title'] . " - [" . makeLink('?', "documentation-".$BLXS['Lang'].".html") . "]" );

eHR();

echo "<form method='post' action='$SCRIPT_NAME'>\n";


// --- STATES ---

if ($action || $outact) {
	$stateNewgroup = ($action==$BLXS['Action_Newgroup']);
	$stateSavegroup = ($action==$BLXS['Action_Savegroup']);

	$stateNewitem = ($action==$BLXS['Action_Newitem']);
	$stateEdititem = ( ($outact=='edititem' || $action==$BLXS['Action_Edititem']) && $itemid);
	$stateSaveitem = ($action==$BLXS['Action_Saveitem']);
	$stateDeleteitem = ($action==$BLXS['Action_Deleteitem'] && $itemid);
	$stateDeleteitemOK = ($action==$BLXS['Action_DeleteitemOK'] && $itemid);

	$stateListitems = ( $outact=='listitems' || $action==$BLXS['Action_Listitems']);
	$stateListitemsAll = ( $outact=='listitemsall' || $action==$BLXS['Action_ListitemsAll']);

	$stateNewblog = ($action==$BLXS['Action_NewPublication']);
	$stateEditblog = ($action==$BLXS['Action_EditPublication']);
	
	$stateSavePubl = ($action==$BLXS['Action_SavePublication']);
	$statePublishPubl = ($action==$BLXS['Action_PublishPublication']);
	$statePublishItem = ( $outact=='publishitem' && $itemid );
}
$stateStart = (!($action || $outact) || $cancel);

// --- START ---

if ($stateStart) {
	ePar(
		makeSubmit('action',$BLXS['Action_Newitem']),
		'actions'
		);

	eH2($BLXS['Editor_Lbl_Groups']);
	ePar(
		makeSelect('','itemgroup',$grp_list,$itemgroup,0) .
		makeSubmit('action',$BLXS['Action_Listitems']) . ' --- ' .
		makeSubmit('action',$BLXS['Action_ListitemsAll']) . ' --- ' .
		makeSubmit('action',$BLXS['Action_Newgroup']),
		'actions'
		);
	
	eH2($BLXS['Publ_Lbl_Publications']);
	if (count($blogs)>0) {
		$buff =
		makeSelect('','blogid',$blog_list,$blogid,0) .
		makeSubmit('action',$BLXS['Action_EditPublication']);
		}
	else $buff = $BLXS['Err_Edit_NoPublication'];
	ePar(
		$buff . ' --- ' .
		makeSubmit('action',$BLXS['Action_NewPublication']),
		'actions'
		);
	}

// --- NEW group ---

if ($stateNewgroup) {
	ePar(makeInput($BLXS['Editor_Lbl_Newgroup'],'newgroup',$newgroup));
	ePar(
		makeSubmit('action',$BLXS['Action_Savegroup']) . " --- " .
		makeSubmit('cancel',$BLXS['Action_Cancel']),
		'actions'
		);
	}

// --- SAVE group ---

if ($stateSavegroup) {
	if ($newgroup) {
		$found = false;
		for ($i=1;$i<count($groups);$i++) if ($groups[$i]==$newgroup) $found = true;
		if ($found) errDie($BLXS['Err_Edit_GroupExists']);
		$gi = count($groups);
		$groups[$gi] = $newgroup;
		saveGroups();
		$itemgroup = $gi;
		$stateListitems = true;
		}
	}

// --- SAVE item ---

if ($stateSaveitem) {
	$er = false;
	$itemtext = trim($itemtext);
	if (!$itemtext) $er = eErr($BLXS['Err_Edit_Emptytext']);
	if (!$er) {
		if (!$itemid) $itemid = time();
		else $oldgr = $items[$itemid][1];
		saveItem($itemid,$itemgroup,$itemtext);
		if ( !($itemgroup==0 && $oldgr==0) ) {
			if ($oldgr>0)
				publishByItem($itemid,$oldgr);
			if ($itemgroup!=$oldgr && $itemgroup>0)
				publishByItem($itemid,$itemgroup);
			}
		$stateListitems = true;
		}
	else {
		if ($itemid) $stateEdititem = true;
		else $stateNewitem = true;
		$saveFault = true;
		}
	}

// --- DELETE item ---

if ($stateDeleteitem) {
	e(makeHidden('itemid',$itemid));
	ePar(makeSubmit('action',$BLXS['Action_DeleteitemOK']) . " " . makeSubmit('cancel',$BLXS['Action_Cancel']), 'actions' );
	}

if ($stateDeleteitemOK) {
	$itemgroup = $items[$itemid][1];
	deleteItem($itemid);
	publishByItem($itemid,$itemgroup);
	$stateListitems = true;
	}

// --- NEW item / EDIT item ---

if ($stateNewitem || $stateEdititem) {
	if ($stateEdititem) {
		eH2($BLXS['Editor_Edit_Title']);
		if (!$saveFault) $itemtext = getItemSource(readItem($itemid));
		e(makeHidden('itemid',$itemid));
		}
	else eH2($BLXS['Editor_Add_Title']);
	ePar(makeTArea($BLXS['Editor_Lbl_Itemtext'],'itemtext',$itemtext,$textarea_rows,$textarea_columns));
	if (!($itemgroup>=0)) $itemgroup = 0;
	ePar(makeSelect($BLXS['Editor_Lbl_Groupname'],'itemgroup',$grp_list,$itemgroup));
	$buff = makeSubmit('action',$BLXS['Action_Saveitem']) . " --- ";
	if ($stateEdititem) $buff .= makeSubmit('action',$BLXS['Action_Deleteitem']) . " ";
	$buff .= makeSubmit('cancel',$BLXS['Action_Cancel']);
	ePar($buff, 'actions');
	}

// --- LIST items ---

if ($stateListitems || $stateListitemsAll) {
	$showall = ($stateListitemsAll || !($itemgroup>=0) );
	if ($showall) {
		eH2($BLXS['Editor_ListAll_Title']);
		}
	else {
		eH2($BLXS['group'] . ': '. $groups[$itemgroup]);
		e(makeHidden('itemgroup',$itemgroup));
		}
	ePar(
		makeSubmit('action',$BLXS['Action_Newitem']). " --- " .
		makeSubmit('cancel',$BLXS['Action_Cancel']),
		'actions'
		);
	$cnt = 0;
	if (count($items)>0) {
		reset ($items);
		while ( list(,$l) = each($items) ) {
			if ($showall || $l[1]==$itemgroup) { $items_list[$cnt] = &$items[$l[0]]; $cnt++; }
			}
		}

	ePar($BLXS['Editor_ItemsCnt'] . ': ' . $cnt, 'listinfo');
	eHR();
	
	if ($cnt) {
		$from = ($listfrom>0) ? $listfrom : 0;
		$to = $cnt-1;
		if (($to-$from)>=$items_perpage) $to = $from+$items_perpage-1;

		eH4($BLXS['Editor_ItemsShow'] . ' ' . ($from+1) . ' - ' . ($to+1) . ':');
		for ($i=$from;$i<=$to;$i++) {
			$st = $items_list[$i][0];
			$gr = $items_list[$i][1];
			$au = getAuthor($items_list[$i][2],false);

			$editURL = "$SCRIPT_NAME?outact=edititem&amp;itemid=$st&amp;itemgroup=$gr";
			$previewURL = "$SCRIPT_NAME?outact=preview&amp;itemid=$st";
			$publishURL = "$SCRIPT_NAME?outact=publishitem&amp;itemid=$st";

			$buff = makeLink(date('d.m.Y,H:i',$st) . ' - ' .
					$BLXS['Editor_Lbl_AddedBy'] . ': ' . $au, $editURL);
			if ($showall) $buff .= ' - [' . $groups[$gr] . ']';
			$buff .= '<br />'.getItemPreview(getItemHTML(readItem($st)),256);
			$buff .= " [" . makeLink($BLXS['edit'],$editURL) . "]";
			$buff .= "-[" . makeLink($BLXS['preview'],$previewURL) . "]";
			$buff .= "-[" . makeLink($BLXS['publish'],$publishURL) . "]";
			$class = ($i%2) ? ('itemodd') : ('itemeven');
			ePar($buff,$class);
			}
		eHR();
		$buff = '';
		$act = ($showall) ? 'listitemsall':'listitems';
		$lnk = "$SCRIPT_NAME?outact=$act&amp;itemgroup=$itemgroup&amp;listfrom=";
		if ($from>0) {
			$prev = $from - $items_perpage;
			if ($prev<0) $prev = 0;
			$buff .= makeLink($BLXS['first'],$lnk."0") . ' ';
			$buff .= makeLink($BLXS['prev'],$lnk.$prev) . ' ';
			}
		if ($to<($cnt-1)) {
			$next = $from + $items_perpage;
			$buff .= makeLink($BLXS['next'],$lnk.$next);
			}
		if ($buff) ePar($buff,'listnavig');
		}
	}

// --- SAVE publication ---

if ($stateSavePubl) {
	$er = false;
	if ($publname=='') $er = eErr($BLXS['Err_Publ_NameEmpty']);
	if ($publitemcnt=='') $er = eErr($BLXS['Err_Publ_CntEmpty']);
	if ($publindexrelpath=='') $er = eErr($BLXS['Err_Publ_IndexpathEmpty']);
	if ($publindextemplate=='') $er = eErr($BLXS['Err_Publ_IndextemplEmpty']);
	if ($publarchivperiod!='0') {
		if ($publarchivrelpath=='') $er = eErr($BLXS['Err_Publ_ArchivpathEmpty']);
		if ($publarchivprefix=='') $er = eErr($BLXS['Err_Publ_ArchivprefixEmpty']);
		if ($publarchivtemplate=='') $er = eErr($BLXS['Err_Publ_ArchivtemplEmpty']);
		}
	if (!$er) {
		if ($blogid==null) $blogid = count($blogs);
		$blogs[$blogid]['name'] = $publname;
		$blogs[$blogid]['desc'] = $publdesc;
		$blogs[$blogid]['itemcnt'] = $publitemcnt;
		$blogs[$blogid]['groups'] = $publgroups;
		$blogs[$blogid]['itemcnt'] = $publitemcnt;
		$blogs[$blogid]['indexrelpath'] = $publindexrelpath;
		$blogs[$blogid]['indextemplate'] = $publindextemplate;
		$blogs[$blogid]['archivperiod'] = $publarchivperiod;
		$blogs[$blogid]['archivrelpath'] = $publarchivrelpath;
		$blogs[$blogid]['archivprefix'] = $publarchivprefix;
		$blogs[$blogid]['archivtemplate'] = $publarchivtemplate;
		savePubl();
		ePar($BLXS['Publ_Saved']);
		ePar(makeSubmit('cancel',$BLXS['Action_Cancel']), 'actions' );
		}
	else {
		if ($blogid) $stateEditblog = true;
		else $stateNewblog = true;
		$saveFault = true;
		}
	}


// NEW / EDIT publication

if ($stateNewblog || $stateEditblog) {	
	if ($stateEditblog) {
		eH2($BLXS['Publ_Edit_Title']);
		if (!$saveFault) {
			$publname = $blogs[$blogid]['name'];
			$publdesc = $blogs[$blogid]['desc'];
			$publitemcnt = $blogs[$blogid]['itemcnt'];
			$publgroups = $blogs[$blogid]['groups'];
			$publitemcnt = $blogs[$blogid]['itemcnt'];
			$publindexrelpath = $blogs[$blogid]['indexrelpath'];
			$publindextemplate = $blogs[$blogid]['indextemplate'];
			$publarchivperiod = $blogs[$blogid]['archivperiod'];
			$publarchivrelpath = $blogs[$blogid]['archivrelpath'];
			$publarchivprefix = $blogs[$blogid]['archivprefix'];
			$publarchivtemplate = $blogs[$blogid]['archivtemplate'];
			}
		e(makeHidden('blogid',$blogid));
		}
	else eH2($BLXS['Publ_Add_Title']);

	ePar(makeInput($BLXS['Publ_Lbl_PublName'],'publname',$publname));
	ePar(makeInput($BLXS['Publ_Lbl_PublDesc'],'publdesc',$publdesc));

	$arr = array();
	$arr[0] = array($BLXS['allgroups'],'all');
	for ($i=1;$i<count($groups);$i++) $arr[$i] = array($groups[$i],$i);
	ePar(makeSelect($BLXS['Publ_Lbl_PublGroups'],'publgroups',$arr,$publgroups));

	ePar(makeInput($BLXS['Publ_Lbl_PublItems'],'publitemcnt',$publitemcnt,5));
	ePar(makeInput($BLXS['Publ_Lbl_PublIndexpath'],'publindexrelpath',$publindexrelpath,40));
	ePar(makeInput($BLXS['Publ_Lbl_PublIndextemplate'],'publindextemplate',$publindextemplate,40));
	$arr = array(
		array($BLXS['week'],'W'),
		array($BLXS['month'],'M'),
		array($BLXS['year'],'Y'),
		array($BLXS['noarchive'],'0')
		);
	ePar(makeSelect($BLXS['Publ_Lbl_PublArchivperiod'],'publarchivperiod',$arr,$publarchivperiod));
	ePar(makeInput($BLXS['Publ_Lbl_PublArchivpath'],'publarchivrelpath',$publarchivrelpath,40));
	ePar(makeInput($BLXS['Publ_Lbl_PublArchivPrefix'],'publarchivprefix',$publarchivprefix));
	ePar(makeInput($BLXS['Publ_Lbl_PublArchivtemplate'],'publarchivtemplate',$publarchivtemplate,40));

	$buff = makeSubmit('action',$BLXS['Action_SavePublication']) . " --- ";
	$buff .= makeSubmit('cancel',$BLXS['Action_Cancel']);
	ePar($buff, 'actions');
	
	ePar($BLXS['Publ_PublishWarning']);

	ePar( makeSubmit('action',$BLXS['Action_PublishPublication']), 'actions');
	}

// PUBLISH

if ($statePublishPubl || $statePublishItem) {
	if ($statePublishItem) {
		if ($itemid) {
			$gr = $items[$itemid][1];
			$found = publishByItem($itemid,$gr);
			if (!$found) errDie($BLXS['Err_NowhereToPublish']);
			}
		else errDie($BLXS['Err_Edit_NoItemID']);
		}
	else {
		if ($blogid>=0) publishBlog($blogid);
		else errDie($BLXS['Err_Edit_NoPublicationID']);
		}
	ePar(makeSubmit('cancel',$BLXS['Action_Cancel']), 'actions');
	}

// ---- FORMATING functions -----

function e($x) { if ($x) echo "$x\n"; }
function eH1($x) { if ($x) echo "<h1>$x</h1>\n"; }
function eH2($x) { if ($x) echo "<h2>$x</h2>\n"; }
function eH4($x) { if ($x) echo "<h4>$x</h4>\n"; }
function ePar($x,$class='') {
	if ($x) {
		if ($class) $cs = " class='$class'";
		echo "<p$cs>$x</p>\n";
		}
	}
function eHR() { echo "<hr />\n"; }
function eErr($x) {
	global $BLXS;
	echo "<p class='error'>".$BLXS['error'].": $x</p>\n";
	return true;
	}
function errDie($x) { eErr($x); die(); }

function makeInput($label,$name,$value,$size='',$maxl='') {
	if ($size) $sizestr = " size='$size'";
	if ($maxl) $maxlstr = " maxlength='$maxl'";
	return "<label for='$name'>$label</label>: \n<input type='text' name='$name' value='$value'$sizestr$maxlstr />\n";
	}
function makeSelect($label,$name,$values,$val,$from=0) {
	$buff = '';
	if ($label) $buff .= "<label for='$name'>$label</label>: \n";
	$buff .= "<select name='$name'>\n";
	for ($i=$from;$i<count($values);$i++) {
		$l = $values[$i];
		$buff .= "<option value='".$l[1]."'";
		if ($l[1]==$val) $buff .= " selected='selected'";
		$buff .= ">".$l[0]."</option>\n";
		}
	$buff .= "</select>\n";
	return $buff;
	}
function makeTArea($label,$name,$value,$rows=15,$cols=50) {
	$buff = '';
	if ($label) $buff .= "<label for='$name'>$label</label>:<br />\n";
	$buff .= "<textarea name='$name' rows='$rows' cols='$cols'>".htmlspecialchars($value)."</textarea>\n";
	return $buff;
	}
function makeHidden($name,$value) { return "<input type='hidden' name='$name' value='$value' />\n"; }
function makeSubmit($name,$value) { return "<input type='submit' name='$name' value='$value' />\n"; }
function makeLink($text,$url,$newwin=0) {
	if ($newwin) $nwstr = " target='_blank'";
	return "<a href='$url'$nwstr>$text</a>";
	}

function fixPath(&$path) {
	if ($path && !eregi('.*\/$',$path)) $path .= '/';
	}

// --- FS functions ---

function saveGroups() {
	global $BLXS, $groups_file, $groups;
	$fn = $groups_file;
	$fp = fopen($fn,"w") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	fwrite($fp,"<?\n\n") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	for ($i=1;$i<count($groups);$i++) {
		fwrite($fp,'$groups['.$i.'] = "'.$groups[$i].'";'."\n") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
		}
	fwrite($fp,"\n\n?".">") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");
	}


function loadItemsList() {
	global $items, $items_file;
	$items = array();
	if (file_exists($items_file)) {
		$its = file($items_file);
		for ($i=0;$i<count($its);$i++ ) {
			$it = trim($its[$i]);
			if ($it) {
				$it = explode("\t",$it);
				$items[$it[0]] = $it;
				}
			}
		}
	}

function saveItemsList() {
	global $BLXS, $items_file, $items;
	rsort($items);
	$fn = $items_file;
	$fp = fopen($fn,"w") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	for ($i=0;$i<count($items);$i++) {
		if ($items[$i])
			fwrite($fp,trim($items[$i][0]."\t".$items[$i][1])."\t".$items[$i][2]."\n") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
		}
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");
	loadItemsList();
	}


function readItem($id) {
	global $path_to_items;
	$fn = $path_to_items."/".$id.".txt";
	if (file_exists($fn)) {
		$arr = file($fn) or errDie($BLXS['Err_FileOpen'] . " ($fn)");
		return $arr;
		}
	else return false;
	}

function saveItem($id,$grp,$txt) {
	global $BLXS, $authID, $path_to_items, $items_file, $items;
	$fn = $path_to_items."/".$id.".txt";
	$fp = fopen($fn,"w") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	fwrite($fp,$txt) or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");
	$items[$id][0] = $id;
	$items[$id][1] = $grp;
	$items[$id][2] = $authID;
	saveItemsList();
	}

function deleteItem($id) {
	global $BLXS, $path_to_items, $items;
	$fn = $path_to_items."/".$id.".txt";
	if (file_exists($fn)) unlink($fn) or errDie($BLXS['Err_FileDelete'] . " ($fn)");
	$items[$id] = null;
	saveItemsList();
	}

function getItemHTML(&$lines) {
	global $BXTagsOK;
	if ($BXTagsOK) return BXTagsParser($lines);
	else return implode('',$lines);
	}

function getItemsource(&$lines) {
	return implode('',$lines);
	}

function getItemPreview($txt,$max=256) {
	global $BLXS;
	if (!$max || !($max>=0)) $max=0;
	$t = preg_replace("/<[^>]*>/s","",$txt);
	if (!$t) return '[-'.$BLXS['empty'].'-]';
	if ($max<1 || strlen($t)<=$max) return $t;
	$t = substr($t,0,$max) . "...";
	return $t;
	}

function getAuthor($id,$email=false) {
	global $authors;
	$a = $authors["$id"];
	if ($a) {
		$buff = $a['name'];
		if ($email && $a['e-mail'])
			$buff = "<a href='mailto:".$a['e-mail']."'>$buff</a>";
		return $buff;
		}
	else return false;
	}

function SavePubl() {
	global $BLXS, $blogs_file, $blogs;

	$fn = $blogs_file;
	$fp = fopen($fn,"w") or errDie($BLXS['Err_FileOpen'] . " ($fn)");
	fwrite($fp,"<?\n\n") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	for ($i=0;$i<count($blogs);$i++) {
		reset($blogs[$i]);
		while(list($k,$l) = each ($blogs[$i]))
			fwrite($fp,'$blogs['.$i."]['$k'] = \"$l\";\n") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
		fwrite($fp,"\n");	
		}
	fwrite($fp,"\n\n?".">") or errDie($BLXS['Err_FileWrite'] . " ($fn)");
	fclose($fp) or errDie($BLXS['Err_FileClose'] . " ($fn)");
	}

function publishByItem($stamp,$group) {
	global $blogs;

	$found = false;
	for ($i=0;$i<count($blogs);$i++) {
		if ($blogs[$i]['groups']=='all' || $blogs[$i]['groups']==$group) {
			publishBlog($i,$stamp);
			$found = true;
			}
		}
	return $found;
	}

function publishBlog($id,$stamp=null) {
	global $BLXS, $blogs, $items;

	$per = $blogs[$id]['archivperiod'];
	$gr = $blogs[$id]['groups'];
	$cnt = $blogs[$id]['itemcnt'];

	$list = array();
	$i = 0;
	reset($items);
	while ($i<$cnt && (list(,$l) = each($items)) ) {
		if ($gr=='all' || $gr==$l[1] )
			$list[] = $l;
		$i++;
		}
	publishPage( $blogs[$id], $list, null );
	
	if ($per!='0') {
		if ($stamp) {
			getPeriod($stamp,$per,$d1,$d2);
			$from = "$d1";
			$to = "$d2";
			$list = array();
			reset($items);
			while (list(,$l) = each($items)) {
				if ($l[0]>=$from && $l[0]<=$to && ($gr=='all' || $gr==$l[1]) )
					$list[] = $l;
				}
			publishPage( $blogs[$id], $list, $d1);
			}
		else {
			$list = array();
			reset($items);
			while(list(,$l) = each($items)) {
				$stamp = $l[0];
				getPeriod($stamp,$per,$d1,$d2);
				$from = "$d1";
				$to = "$d2";
				if ($stamp>=$from && $stamp<=$to && ($gr=='all' || $gr==$l[1]) )
					$list[$d1][] = $l;
				}
			while(list($k,$l) = each($list)) publishPage( $blogs[$id], $l, $k);
			}
		publishArchive($blogs[$id]);
		}
	}
	


?>

</form>

</body>
</html>
